#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <iostream>

using namespace cv;
using namespace std;

int main() {
  int big, x, y;
  int iLowH(4), iLowS(40), iLowV(40), iHighH(15), iHighS(255), iHighV(255);
  VideoCapture cap(0);
  Mat frame, hsv, test, thresh, threshCopy;
  vector<Mat> channels;
  namedWindow("FRAME");
  namedWindow("THRESH");
  namedWindow("TEST");
  moveWindow("FRAME", 0, 100);
  moveWindow("THRESH", 400, 375);
  moveWindow("TEST", 400, 100);
  createTrackbar("LowH", "FRAME", &iLowH, 179);
  createTrackbar("HighH", "FRAME", &iHighH, 179);
  createTrackbar("LowS", "FRAME", &iLowS, 255);
  createTrackbar("HighS", "FRAME", &iHighS, 255);
  createTrackbar("LowV", "FRAME", &iLowV, 255);
  createTrackbar("HighV", "FRAME", &iHighV, 255);

  for(;;) {
    cap >> frame;
    resize(frame, frame, Size(320, 240));
    blur(frame, frame, Size(3, 3));
    cvtColor(frame, hsv, CV_BGR2HSV);
    split(hsv, channels);
    inRange(hsv, Scalar( iLowH, iLowS, iLowV), Scalar(iHighH, iHighS, iHighV), thresh);
//    thresh.copyTo(test);
    erode(thresh, thresh, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)));
//    thresh.copyTo(test);
    dilate(thresh, thresh, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)));
//    thresh.copyTo(test);
    dilate(thresh, thresh, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)));
//    thresh.copyTo(test);
    erode(thresh, thresh, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)));
    vector<vector<Point> > contours;
    vector<Vec4i> hierarchy;
    thresh.copyTo(test);
    findContours(thresh, contours, hierarchy, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE, Point(0, 0));
    vector<Moments> mu(contours.size());
    int maxArea(0);
    for (unsigned int cnt(0); cnt < contours.size(); cnt++) {
      int area = contourArea(contours[cnt]);
      mu[cnt] = moments(contours[cnt], false);
      if (area > maxArea) {
        maxArea = area;
        big = cnt;
      }
    }
    if (maxArea > 0) {
      x = mu[big].m10 / mu[big].m00;
      y = mu[big].m01 / mu[big].m00;
      rectangle(frame, Point(x - 5, y -5), Point(x + 5, y + 5), Scalar(0, 255, 0), 2, 8, 0);
    }
    imshow("FRAME", frame);
    imshow("THRESH", test);
    imshow("TEST", channels[0]);
    if (waitKey(1) == 27) {
      cap.release();
      destroyAllWindows();
      break;
    }
  }
}
